* PACKAGE DCHEB  !" ϳ ӥմؿŸ
*
*"  [HIS] 92/09/18(takepiro)
*"        92/11/09(takepiro)
*
**********************************************************************
      SUBROUTINE C2W     !" ӥѴ (ʻ)
     M         ( WDATA ,
     I           CDATA ,
     I           HGRAD , HFUNC , KMAXD )
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻȿ
      INCLUDE   (ZCCOM)                      !" ɸʪ
#else
#include        "zcdim.F"                    !" ʻȿ
#include        "zccom.F"                    !" ɸʪ
#endif
*
      INTEGER    KMAXD
*
*   [MODIFY] 
      REAL       WDATA ( NMDIM, KMAXD )      !" ư³ʻǡ
*
*   [INPUT] 
      REAL       CDATA ( NMDIM, KMAXD )      !" ư¥ӥեǡ
      CHARACTER  HGRAD*4                     !" ʬե饰
      CHARACTER  HFUNC*4                     !" ե饰
*
*
*   [INTERNAL WORK] 
      REAL       QCHEB ( 0:KDIM, 0:KDIM )    !" ӥմؿ Tj(x_k)
      REAL       QXSI  ( 0:KDIM  )           !" ӥեݥ x_k
      REAL       DRFAC                       !" ʬΥե
*
      REAL       WORK  ( NMDIM, KMAX )       !" ΰ
      REAL       CHEB  ( NMDIM, KMAX )       !" ΰ
*
      REAL       PI
      INTEGER    J, K
      LOGICAL    OFRSTG , OFRSTC
      DATA       OFRSTG , OFRSTC / .TRUE., .TRUE. /
*
      SAVE
*
*"   < 0. ӥեݥȤη׻ > 
*
      IF ( OFRSTC ) THEN
         OFRSTC = .FALSE. 
*
         DRFAC = 2. / ( ERO - ERI )
         PI = 4.0 * ATAN ( 1.0 )
         DO 8100 K = 0, KDIM
            QXSI ( K ) = COS( PI* K / KDIM ) !" ӥեݥ
 8100    CONTINUE
      ENDIF
*
      CALL CHBC2G
     M       (  WDATA , 
     I          CDATA , 
     C          QXSI  , DRFAC ,
     F          HGRAD , HFUNC , 
     D          NMDIM , KMAX  , 
     W          CHEB  , WORK       )
*
      RETURN
*======================================================================
      ENTRY      W2C      !"  ӥѴ (ʻҢڥȥ) 
     M         ( CDATA ,
     I           WDATA ,
     I           HGRAD , HFUNC , KMAXD )
*
*"   < 0. ʬΥե, ӥմؿη׻ > 
*
      IF ( OFRSTG ) THEN
         OFRSTG = .FALSE. 
*
         DRFAC = 2. / ( ERO - ERI )
         PI = 4.D0 * ATAN ( 1.D0 )
         DO 100 K = 0, KDIM
            DO 100 J = 0, KDIM
               QCHEB( J, K ) = COS( J * PI * K / KDIM )
 100    CONTINUE
      ENDIF
*
      CALL CHBG2C
     M       (  CDATA , 
     I          WDATA , 
     C          QCHEB , DRFAC ,
     F          HGRAD , HFUNC , 
     D          NMDIM , KMAX  , 
     W          CHEB  , WORK       )
*
      RETURN
      END
**********************************************************************
      SUBROUTINE CDERIV     !" ӥʬ
     O         ( CDDATA ,
     I           CDATA ,
     I           KMAXD )
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻȿ
      INCLUDE   (ZCCOM)                      !" ɸʪ
#else
#include        "zcdim.F"                    !" ʻȿ
#include        "zccom.F"                    !" ɸʪ
#endif
*
      INTEGER    KMAXD
*
*   [OUTPUT] 
      REAL       CDDATA ( NMDIM, KMAXD )      !" ư³ʻǡ
*
*   [INPUT] 
      REAL       CDATA ( NMDIM, KMAXD )      !" ư¥ӥեǡ
*
      REAL       DRFAC                       !" ʬΥե
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
*
      IF ( OFIRST ) THEN
         OFIRST = .FALSE. 
         DRFAC = 2. / ( ERO - ERI )
      ENDIF
*
      CALL CHBDER
     O              ( CDDATA, 
     I                CDATA , DRFAC , 
     M                NMDIM , KMAXD    )
*
      RETURN
      END

